#include <stdio.h>

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int mincost[4];    /* min cost to node 0 ... 3 */
  };

extern int TRACE;
extern int YES;
extern int NO;

struct distance_table 
{
  int costs[4][4];
} dt3;

/* students to write the following two routines, and maybe some others */

static int update_flag = 0;
static int stored_mincost[4] = {999, 999, 999, 999};

void rtinit3() 
{
  struct rtpkt packet;
  struct distance_table *dtptr;

  dt3.costs[0][0] = 7;
  dt3.costs[2][2] = 2;
  dt3.costs[0][2] = 999;
  dt3.costs[1][0] = 999;
  dt3.costs[1][2] = 999;
  dt3.costs[2][0] = 999;
  packet.sourceid = 3;
  packet.destid = 0;
  packet.mincost[0] = 7;
  packet.mincost[1] = 999;
  packet.mincost[2] = 2;
  packet.mincost[3] = 0;
  tolayer2(packet);
  packet.destid = 2;
  tolayer2(packet);
  dtptr = &dt3;
  printdt3(dtptr);
}


void rtupdate3(rcvdpkt)
  struct rtpkt *rcvdpkt;
  
{
  struct rtpkt packet;
  struct distance_table *dtptr;
  int min = 0;

  if (rcvdpkt->sourceid == 0)
  {
    if (rcvdpkt->mincost[1] != 0)
    {
      dt3.costs[1][0] = dt3.costs[0][0] + rcvdpkt->mincost[1];
    }
    if (rcvdpkt->mincost[2] != 0)
    {
      dt3.costs[0][2] = dt3.costs[2][2] + rcvdpkt->mincost[2];  
      dt3.costs[2][0] = dt3.costs[0][0] + rcvdpkt->mincost[2];
    }
  }

  if (rcvdpkt->sourceid == 2)
  {
    if (rcvdpkt->mincost[0] != 0)
    {
      dt3.costs[0][2] = dt3.costs[2][2] + rcvdpkt->mincost[0];
      dt3.costs[2][0] = dt3.costs[0][0] + rcvdpkt->mincost[0];
    }
    if (rcvdpkt->mincost[1] != 0)
    {
      dt3.costs[1][2] = dt3.costs[2][2] + rcvdpkt->mincost[1];  
    }
  }
  min = (dt3.costs[0][0] < dt3.costs[0][2]) ? (dt3.costs[0][0]) : (dt3.costs[0][2]);
  if (min != stored_mincost[0])
  {
        packet.mincost[0] = min;
        stored_mincost[0] = min;
        update_flag = 1;
  }
  else
  {
        packet.mincost[0] = 0;
  }

  min = (dt3.costs[1][0] < dt3.costs[1][2]) ? (dt3.costs[1][0]) : (dt3.costs[1][2]);
  if (min != stored_mincost[1])
  {
        packet.mincost[1] = min;
        stored_mincost[1] = min;
        update_flag = 1;
  }
  else
  {
        packet.mincost[1] = 0;
  }

  min = (dt3.costs[2][0] < dt3.costs[2][2]) ? (dt3.costs[2][0]) : (dt3.costs[2][2]);
  if (min != stored_mincost[2])
  {
        packet.mincost[2] = min;
        stored_mincost[2] = min;
        update_flag = 1;
  }
  else
  {
        packet.mincost[2] = 0;
  }

  if (update_flag == 1)
  {
        packet.mincost[3] = 0;
        packet.sourceid = 3;
        packet.destid = 0;
        tolayer2(packet);
        packet.destid = 2;
        tolayer2(packet);
        update_flag = 0;
  }
  dtptr = &dt3;
  printdt3(dtptr);
}


printdt3(dtptr)
  struct distance_table *dtptr;
  
{
  printf("             via     \n");
  printf("   D3 |    0     2 \n");
  printf("  ----|-----------\n");
  printf("     0|  %3d   %3d\n",dtptr->costs[0][0], dtptr->costs[0][2]);
  printf("dest 1|  %3d   %3d\n",dtptr->costs[1][0], dtptr->costs[1][2]);
  printf("     2|  %3d   %3d\n",dtptr->costs[2][0], dtptr->costs[2][2]);

}







